%define base_name       geronimo
%define name            %{base_name}-assembly
%define version         1.0
%define mstone       	M2
%define release         0.%{mstone}.2jpp
%define section         free
%define source_top      %{name}-%{cvs_version}

Summary:        Geronimo J2EE server 
URL:            http://geronimo.apache.org
Source0:        geronimo-1.0-M2-src.tar.gz
Source1:        pom-maven2jpp-depcat.xsl
Source2:        pom-maven2jpp-newdepmap.xsl
Source3:        pom-maven2jpp-mapdeps.xsl
Source4:        geronimo-assembly-1.0-M2-jpp-depmap.xml
Source5:	geronimo.conf
Source6:	geronimo.init
Source7:	geronimo.policy
Source8:	geronimo.script
Source9:	geronimo.relink

Patch0:         geronimo-assembly-1.0-M2-jpp.patch

Name:           %{name}
Version:        %{version}
Release:        %{release}
Epoch:          0
License:        Apache Software License 2
Group:          Development/Libraries/Java
Vendor:         JPackage Project
Distribution:   JPackage
BuildArch:      noarch
BuildRequires:  jpackage-utils >= 0:1.6
BuildRequires:  maven >= 0:1.0
BuildRequires:  saxon, saxon-scripts
#
BuildRequires:	ant >= 0:1.6
BuildRequires:	asm >= 0:1.4.3
BuildRequires:	axion >= 0:1.0-0.M3
BuildRequires:	castor
BuildRequires:	cglib >= 0:2.0.2
BuildRequires:	concurrent >= 0:1.3.4
BuildRequires:	geronimo-modules >= 0:1.0-0.M2
BuildRequires:	geronimo-specs >= 0:1.0-0.M2
BuildRequires:	howl-logger >= 0:0.1.7
BuildRequires:	jakarta-commons-cli
BuildRequires:	jakarta-commons-collections >= 0:3.1
BuildRequires:	jakarta-commons-el
BuildRequires:	jakarta-commons-fileupload
BuildRequires:	jakarta-commons-jelly-tags-velocity >= 0:1.0-0.rc1
BuildRequires:	jakarta-commons-logging
BuildRequires:	jakarta-commons-primitives
BuildRequires:	jasper5 >= 0:5.0
BuildRequires:	jetty50 >= 0:5.0
BuildRequires:	jetty50-extra >= 0:5.0
BuildRequires:	junit
BuildRequires:	log4j
BuildRequires:	mx4j >= 0:2.0.1
BuildRequires:	openejb >= 0:2.0-0.M2
BuildRequires:	regexp >= 0:1.3
BuildRequires:	tranql >= 0:1.0-0.M2
BuildRequires:	tranql-connector >= 0:1.0-0.M2
BuildRequires:	velocity >= 0:1.4
BuildRequires:	xerces-j2
BuildRequires:	xmlbeans
BuildRequires:	xml-commons-apis
BuildRequires:	xpp3
BuildRequires:	xstream
#
Requires:	ant >= 0:1.6
Requires:	asm >= 0:1.4.3
Requires:	axion >= 0:1.0-0.M3
Requires:	castor
Requires:	cglib >= 0:2.0.2
Requires:	concurrent >= 0:1.3.4
Requires:	geronimo-modules >= 0:1.0-0.M2
Requires:	geronimo-specs >= 0:1.0-0.M2
Requires:	howl-logger >= 0:0.1.7
Requires:	jakarta-commons-cli
Requires:	jakarta-commons-collections >= 0:3.1
Requires:	jakarta-commons-el
Requires:	jakarta-commons-fileupload
Requires:	jakarta-commons-jelly-tags-velocity >= 0:1.0-0.rc1
Requires:	jakarta-commons-logging
Requires:	jakarta-commons-primitives
Requires:	jasper5 >= 0:5.0
Requires:	jetty50 >= 0:5.0
Requires:	jetty50-extra >= 0:5.0
Requires:	junit
Requires:	log4j
Requires:	mx4j >= 0:2.0.1
Requires:	openejb >= 0:2.0-0.M2
Requires:	regexp >= 0:1.3
Requires:	tranql >= 0:1.0-0.M2
Requires:	tranql-connector >= 0:1.0-0.M2
Requires:	velocity >= 0:1.4
Requires:	xerces-j2
Requires:	xmlbeans
Requires:	xml-commons-apis
Requires:	xpp3
Requires:	xstream

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
Geronimo is Apache's ASF-licenced J2EE server project.


%package demo
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description demo
Demo for %{name}.

%prep
%setup -q -n geronimo-1.0-M2
chmod -R go=u-w *
rm -rf applications/jmxdebug
rm -rf sandbox
rm -rf specs

export DEPCAT=$(pwd)/geronimo-assembly-1.0-M2-depcat.new.xml
echo '<?xml version="1.0" standalone="yes"?>' > $DEPCAT
echo '<depset>' >> $DEPCAT
for p in $(find . -name project.xml); do
    pushd $(dirname $p)
    /usr/bin/saxon project.xml %{SOURCE1} >> $DEPCAT
    popd 
done 
echo >> $DEPCAT
echo '</depset>' >> $DEPCAT
/usr/bin/saxon $DEPCAT %{SOURCE2} > geronimo-assembly-1.0-M2-depmap.new.xml

%patch0 -b .sav

%build
for p in $(find . -name project.xml); do
    pushd $(dirname $p)
    cp project.xml project.xml.orig
    /usr/bin/saxon -o project.xml project.xml.orig %{SOURCE3} map=%{SOURCE4}
    popd 
done 
 
for p in $(find . -name project.properties); do
    echo >> $p
    echo maven.repo.remote=file:/usr/share/maven-1.0/repository >> $p
    echo maven.home.local=$(pwd)/.maven >> $p
done 

mkdir -p .maven/repository/JPP/rars
pushd .maven/repository/JPP/rars
    ln -sf %{_javadir}/tranql-connector.rar tranql-connector.rar
popd
mkdir -p .maven/repository/JPP/wars
pushd .maven/repository/JPP/wars
    ln -sf %{_javadir}/geronimo/console-web.war geronimo-console-web.war
    ln -sf %{_javadir}/geronimo/jmxdebug.war geronimo-jmxdebug.war
popd
mkdir -p .maven/repository/JPP/jars
#activemq \
pushd .maven/repository/JPP/jars
ln -sf $(build-classpath ant) ant.jar
ln -sf $(build-classpath asm/asm) asm-asm.jar
ln -sf $(build-classpath axion) axion.jar
ln -sf $(build-classpath castor) castor.jar
ln -sf $(build-classpath cglib) cglib.jar
ln -sf $(build-classpath commons-collections) commons-collections.jar
ln -sf $(build-classpath commons-cli) commons-cli.jar
ln -sf $(build-classpath commons-el) commons-el.jar
ln -sf $(build-classpath commons-fileupload) commons-fileupload.jar
ln -sf $(build-classpath commons-jelly-tags-velocity) commons-jelly-tags-velocity.jar
ln -sf $(build-classpath commons-logging) commons-logging.jar
ln -sf $(build-classpath commons-primitives) commons-primitives.jar
ln -sf $(build-classpath concurrent) concurrent.jar
ln -sf $(build-classpath geronimo/clustering) geronimo-clustering.jar
ln -sf $(build-classpath geronimo/common) geronimo-common.jar
ln -sf $(build-classpath geronimo/connector) geronimo-connector.jar
ln -sf $(build-classpath geronimo/core) geronimo-core.jar
ln -sf $(build-classpath geronimo/core-rmiclassloaderspi) geronimo-core-rmiclassloaderspi.jar
ln -sf $(build-classpath geronimo/deployment) geronimo-deployment.jar
ln -sf $(build-classpath geronimo/j2ee) geronimo-j2ee.jar
ln -sf $(build-classpath geronimo/j2ee-schema) geronimo-j2ee-schema.jar
ln -sf $(build-classpath geronimo/jetty) geronimo-jetty.jar
ln -sf $(build-classpath geronimo/jmxremoting) geronimo-jmxremoting.jar
ln -sf $(build-classpath geronimo/kernel) geronimo-kernel.jar
ln -sf $(build-classpath geronimo/naming) geronimo-naming.jar
ln -sf $(build-classpath geronimo/network) geronimo-network.jar
ln -sf $(build-classpath geronimo/remoting) geronimo-remoting.jar
ln -sf $(build-classpath geronimo/security) geronimo-security.jar
ln -sf $(build-classpath geronimo/spec-ejb-2.1) geronimo-spec-ejb-2.1.jar
ln -sf $(build-classpath geronimo/spec-j2ee-1.4) geronimo-spec-j2ee-1.4.jar
ln -sf $(build-classpath geronimo/spec-j2ee-connector-1.5) geronimo-spec-j2ee-connector-1.5.jar
ln -sf $(build-classpath geronimo/spec-j2ee-deployment-1.1) geronimo-spec-j2ee-deployment-1.1.jar
ln -sf $(build-classpath geronimo/spec-j2ee-jacc-1.0) geronimo-spec-j2ee-jacc-1.0.jar
ln -sf $(build-classpath geronimo/spec-j2ee-management-1.0) geronimo-spec-j2ee-management-1.0.jar
ln -sf $(build-classpath geronimo/spec-j2eeschema-1.0) geronimo-spec-j2eeschema-1.0.jar
ln -sf $(build-classpath geronimo/spec-jms-1.1) geronimo-spec-jms-1.1.jar
ln -sf $(build-classpath geronimo/spec-jsp-2.0) geronimo-spec-jsp-2.0.jar
ln -sf $(build-classpath geronimo/spec-jta-1.0.1B) geronimo-spec-jta-1.0.1B.jar
ln -sf $(build-classpath geronimo/spec-servlet-2.4) geronimo-spec-servlet-2.4.jar
ln -sf $(build-classpath geronimo/system) geronimo-system.jar
ln -sf $(build-classpath geronimo/timer) geronimo-timer.jar
ln -sf $(build-classpath geronimo/transaction) geronimo-transaction.jar
ln -sf $(build-classpath howl-logger) howl-logger.jar
ln -sf $(build-classpath jasper5-compiler) jasper5-compiler.jar
ln -sf $(build-classpath jasper5-runtime) jasper5-runtime.jar
ln -sf $(build-classpath jetty50/jetty50) jetty50-jetty50.jar
ln -sf $(build-classpath jetty50/jetty50-jaas) jetty50-jetty50-jaas.jar
ln -sf $(build-classpath junit) junit.jar
ln -sf $(build-classpath log4j) log4j.jar
ln -sf $(build-classpath mx4j/mx4j) mx4j-mx4j.jar
ln -sf $(build-classpath mx4j/mx4j-jmx) mx4j-mx4j-jmx.jar
ln -sf $(build-classpath mx4j/mx4j-remote) mx4j-mx4j-remote.jar
ln -sf $(build-classpath openejb/core) openejb-core.jar
ln -sf $(build-classpath openejb/itests) openejb-itests.jar
ln -sf $(build-classpath openejb/jca) openejb-jca.jar
ln -sf $(build-classpath regexp) regexp.jar
ln -sf $(build-classpath tranql) tranql.jar
ln -sf $(build-classpath tranql-connector) tranql-connector.jar
ln -sf $(build-classpath velocity) velocity.jar
ln -sf $(build-classpath xmlbeans/xbean) xmlbeans-xbean.jar
ln -sf $(build-classpath xerces-j2) xerces-j2.jar
ln -sf $(build-classpath xml-commons-apis) xml-commons-apis.jar
ln -sf $(build-classpath xpp3) xpp3.jar
ln -sf $(build-classpath xstream) xstream.jar
popd

mkdir -p .maven/repository/JPP/plugins
pushd .maven/repository/JPP/plugins
ln -sf $(build-classpath geronimo/xmlbeans-plugin) geronimo-xmlbeans-plugin.jar
ln -sf $(build-classpath geronimo/deployment-plugin) geronimo-deployment-plugin.jar
popd

maven -Dmaven.home.local=$(pwd)/.maven \
	-Dmodules=demo,assembly

%install
rm -rf $RPM_BUILD_ROOT

# server
install -d -m 0755 $RPM_BUILD_ROOT%{_datadir}/%{base_name}-%{version}
pushd $RPM_BUILD_ROOT%{_datadir}/%{base_name}-%{version}
jar xf ${RPM_BUILD_DIR}/%{base_name}-%{version}-%{mstone}/modules/assembly/target/%{name}-%{version}-%{mstone}.jar
popd
install -m 0755 %{SOURCE9} $RPM_BUILD_ROOT%{_datadir}/%{base_name}-%{version}/bin/relink

# config
install -d -m 0755 $RPM_BUILD_ROOT%{_sysconfdir}/%{base_name}
install -m 0644 %{SOURCE5} $RPM_BUILD_ROOT%{_sysconfdir}/%{base_name}/geronimo.conf
install -m 0644 %{SOURCE7} $RPM_BUILD_ROOT%{_sysconfdir}/%{base_name}/geronimo.policy

# scripts
install -d -m 0755 $RPM_BUILD_ROOT%{_bindir}
install -m 0755 %{SOURCE8} $RPM_BUILD_ROOT%{_bindir}/d%{base_name}
install -d -m 0755 $RPM_BUILD_ROOT%{_initrddir}
install -m 0755 %{SOURCE6} $RPM_BUILD_ROOT%{_initrddir}/%{base_name}

# var
install -d -m 0755 $RPM_BUILD_ROOT%{_localstatedir}/%{base_name}
mv $RPM_BUILD_ROOT%{_datadir}/%{base_name}-%{version}/var/* \
	$RPM_BUILD_ROOT%{_localstatedir}/%{base_name}
rm -rf $RPM_BUILD_ROOT%{_datadir}/%{base_name}-%{version}/var
ln -s %{_localstatedir}/%{base_name} \
	$RPM_BUILD_ROOT%{_datadir}/%{base_name}-%{version}/var

# no jars

# demo
install -d -m 0755 $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}
install -p -m 0644 \
	applications/demo/target/%{base_name}-demo-%{version}-%{mstone}.war \
	$RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/%{base_name}-demo-%{version}.war

%clean
rm -rf $RPM_BUILD_ROOT

%post
id geronimo && chown -R geronimo %{_localstatedir}/%{base_name}
%{_datadir}/%{base_name}-%{version}/bin/relink


%files
%defattr(-,root,root,-)
%{_datadir}/%{base_name}-%{version}
%{_localstatedir}/%{base_name}
%attr(755, root, root) %{_bindir}/*
%attr(755, root, root) %{_initrddir}/%{base_name}
%dir %{_sysconfdir}/%{base_name}
%config(noreplace) %{_sysconfdir}/%{base_name}/*

%files demo
%defattr(0644,root,root,0755)
%{_datadir}/%{name}-%{version}

%changelog
* Thu Feb 03 2005 Ralph Apel <r.apel at r-apel.de> 0:1.0-0.M2-2jpp
- Process project.xml files with saxon
- Don't tamper with $HOME
- No geronimo user yet

* Fri Jan 28 2005 Ralph Apel <r.apel at r-apel.de> 0:1.0-0.M2-1jpp
- Upgrade to M2

* Tue Sep 28 2004 Ralph Apel <r.apel at r-apel.de> 0:1.0-0.M1-1jpp
- First JPackage build 

